<!DOCTYPE HTML PUBLIC "-//FreeBSD//DTD HTML 4.01 Transitional-Based Extension//EN" [
<!ENTITY base CDATA "../..">
<!ENTITY date "$FreeBSD$">
<!ENTITY title "FreeBSD 9.0-RELEASE Release Notes">
<!ENTITY % navinclude.download "INCLUDE">
]>
<html>
  &header;

  <div class="IMPORTANT">
    <blockquote class="IMPORTANT">
      <p><b>Important:</b> If you are upgrading from a previous release of
	FreeBSD, please read <a
	  href="http://www.FreeBSD.org/releases/9.0R/relnotes-detailed.html#UPGRADE"
	  target="_top">upgrading section in the Release Notes</a> for notable
	incompatibilities carefully.</p>
      </blockquote>
  </div>

  <h2>Release Highlights</h2>

  <p>The highlights in the 9.0-RELEASE are the following.  For more
    details, please see <a href="relnotes-detailed.html">the Detailed
    Release Notes</a>.</p>

  <ul>
    <li><p>The FreeBSD kernel now supports Capsicum Capability Mode. Capsicum is a set of
	features for sandboxing support, using a capability model in which the capabilities are
	file descriptors. Two new kernel options <tt class="LITERAL">CAPABILITIES</tt> and <tt
	  class="LITERAL">CAPABILITY_MODE</tt> have been added to the <tt
	  class="FILENAME">GENERIC</tt> kernel. For more information about Capsicum, see <a
	  href="http://www.cl.cam.ac.uk/research/security/capsicum/"
	  target="_top">http://www.cl.cam.ac.uk/research/security/capsicum/</a>.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=219129"
	  target="_top">r219129</a>]</p></li>

    <li><p>The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=hhook&amp;sektion=9&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">hhook</span>(9)</span></a> (Helper
	  Hook) and <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=khelp&amp;sektion=9&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">khelp</span>(9)</span></a> (Kernel
	  Helpers) KPIs have been implemented. These are a kind of
	  superset of <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=pfil&amp;sektion=9&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">pfil</span>(9)</span></a> framework
	  for more general use in the kernel. The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=hhook&amp;sektion=9&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">hhook</span>(9)</span></a> KPI
	  provides a way for kernel subsystems to export hook points
	  that <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=khelp&amp;sektion=9&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">khelp</span>(9)</span></a> modules can
	  hook to provide enhanced or new functionality to the
	  kernel. The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=khelp&amp;sektion=9&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">khelp</span>(9)</span></a> KPI
	  provides a framework for managing <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=khelp&amp;sektion=9&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">khelp</span>(9)</span></a> modules,
	  which indirectly use the <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=hhook&amp;sektion=9&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">hhook</span>(9)</span></a> KPI to
	  register their hook functions with hook points of interest
	  within the kernel. These allow a structured way to
	  dynamically extend the kernel at runtime in an ABI
	  preserving manner.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=216758"
	  target="_top">r216758</a>, <a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=216615"
	  target="_top">r216615</a>]</p></li>

    <li><p>A new resource accounting API has been implemented. It can
	keep per-process, per-jail, and per-loginclass resource
	accounting information. Note that this is not built nor
	installed by default. To build and install them, specify <tt
	class="LITERAL">options RACCT</tt> in the kernel configuration
	file and rebuild the base system as described in the <a
	href="http://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/makeworld.html"
	target="_top">FreeBSD Handbook</a>.[<a
	href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=220137"
	target="_top">r220137</a>]</p></li>

    <li><p>A new resource-limiting API has been implemented. It works
	in conjunction with the <tt class="LITERAL">RACCT</tt>
	resource accounting implementation and takes user-configurable
	actions based on the set of rules it maintains and the current
	resource usage. The <a
	href="http://www.FreeBSD.org/cgi/man.cgi?query=rctl&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	<span class="CITEREFENTRY"><span
	class="REFENTRYTITLE">rctl</span>(8)</span></a> utility has
	been added to manage the rules in userland. Note that this is
	not built nor installed by default. To build and install them,
	specify <tt class="LITERAL">options RCTL</tt> in the kernel
	configuration file and rebuild the base system as described in
	the <a
	href="http://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/makeworld.html"
	target="_top">FreeBSD Handbook</a>.[<a
	href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=220163"
	target="_top">r220163</a>]</p></li>

    <li><p>[powerpc] FreeBSD/powerpc now supports Sony Playstation 3
	using the OtherOS feature available on firmwares 3.15 and
	earlier.[<a
	href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=217044"
	target="_top">r217044</a>]</p></li>

    <li><p>[amd64, i386] The FreeBSD <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=usb&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">usb</span>(4)</span></a> subsystem now
	  supports USB 3.0 by default.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=223098"
	  target="_top">r223098</a>]</p></li>

    <li><p>The FreeBSD <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=usb&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">usb</span>(4)</span></a> subsystem now
	  supports USB packet filter. This allows to capture packets
	  which go through each USB host controller. The
	  implementation is almost based on <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=bpf&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">bpf</span>(4)</span></a> code. The
	  userland program <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=usbdump&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">usbdump</span>(8)</span></a> has been
	  added.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=215649"
	  target="_top">r215649</a>]</p></li>

    <li><p>A bxe(4) driver for Broadcom NetXtreme II 10GbE controllers
	(BCM57710, BCM57711, BCM57711E) has been added.[<a
	href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=219647"
	target="_top">r219647</a>]</p></li>

    <li><p>A <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=cxgbe&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">cxgbe</span>(4)</span></a> driver for
	  Chelsio T4 (Terminator 4) based 10Gb/1Gb adapters has been
	  added.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=218794"
	  target="_top">r218794</a>]</p></li>

    <li><p>The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=em&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE"><span
	  class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">em</span>(4)</span></a> driver has
	  been updated to version 7.3.2.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=219753"
	  target="_top">r219753</a>]</p></li>

    <li><p>The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=igb&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">igb</span>(4)</span></a> driver has
	  been updated to version 2.2.5.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=223350"
	  target="_top">r223350</a>]</p></li>

    <li><p>The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=igb&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">igb</span>(4)</span></a> driver now
	  supports Intel I350 PCIe Gigabit Ethernet controllers.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=218530"
	  target="_top">r218530</a>]</p></li>

    <li><p>The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=ixgbe&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">ixgbe</span>(4)</span></a> driver has
	  been updated to version 2.3.8.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=217593"
	  target="_top">r217593</a>]</p></li>

    <li><p>The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=re&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE"><span
	  class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">re</span>(4)</span></a> driver now
	  supports RTL8168E/8111E-VL PCIe Gigabit Ethernet controllers
	  and RTL8401E PCIe Fast Ethernet controllers.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=217498"
	  target="_top">r217498</a>, <a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=218760"
	  target="_top">r218760</a>]</p></li>

    <li><p>A <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=vte&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">vte</span>(4)</span></a> driver for
	  RDC R6040 Fast Ethernet controllers, which are commonly
	  found on the Vortex86 System On a Chip, has been added.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=216829"
	  target="_top">r216829</a>]</p></li>

    <li><p>A <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=vxge&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">vxge</span>(4)</span></a> driver for
	  the Neterion X3100 10GbE Server/Storage adapter has been
	  added.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=221167"
	  target="_top">r221167</a>]</p></li>

    <li><p><a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">ipfw</span>(8)</span></a> now supports
	  IPv6 in the <tt class="COMMAND">fwd</tt> action.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=225044"
	  target="_top">r225044</a>]</p></li>

    <li><p><a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">ipfw</span>(8)</span></a> now supports
	  the <tt class="COMMAND">call</tt> and <tt
	  class="COMMAND">return</tt> actions.  Upon the <tt
	  class="COMMAND">call <tt
	  class="REPLACEABLE"><i>number</i></tt></tt> action, the
	  current rule number is saved in the internal stack and
	  ruleset processing continues with the first rule numbered
	  <tt class="REPLACEABLE"><i>number</i></tt> or higher. The
	  <tt class="COMMAND">return</tt> action takes the rule number
	  saved to internal stack by the latest <tt
	  class="COMMAND">call</tt> action and returns ruleset
	  processing to the first rule with number greater than that
	  saved number.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=223666"
	  target="_top">r223666</a>]</p></li>

    <li><p>For Infiniband support, OFED (OpenFabrics Enterprise
	Distribution) version 1.5.3 has been imported into the base
	system. Note that this is not built nor installed by default.
	To build and install them, specify <tt
	class="LITERAL">WITH_OFED=yes</tt> in <tt
	class="FILENAME">/etc/src.conf</tt> and rebuild the base
	system as described in the <a
	href="http://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/makeworld.html"
	target="_top">FreeBSD Handbook</a>.[<a
	href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=219820"
	target="_top">r219820</a>]</p></li>

    <li><p>The FreeBSD TCP/IP network stack now supports IPv4 prefixes
	with /31 as described in RFC 3021, &#8220;Using 31-Bit
	Prefixes on IPv4 Point-to-Point Links&#8221;.[<a
	href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=226572"
	target="_top">r226572</a>]</p></li>

    <li><p>The FreeBSD TCP/IP network stack now supports the <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=mod_cc&amp;sektion=9&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">mod_cc</span>(9)</span></a> pluggable
	  congestion control framework. This allows TCP congestion
	  control algorithms to be implemented as dynamically loadable
	  kernel modules. The following kernel modules are available
	  as of 9.0-RELEASE: <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=cc_chd&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">cc_chd</span>(4)</span></a> for the
	  CAIA-Hamilton-Delay algorithm, <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=cc_cubic&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">cc_cubic</span>(4)</span></a> for the
	  CUBIC algorithm, <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=cc_hd&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">cc_hd</span>(4)</span></a> for the
	  Hamilton-Delay algorithm, <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=cc_htcp&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">cc_htcp</span>(4)</span></a> for the
	  H-TCP algorithm, <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=cc_newreno&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">cc_newreno</span>(4)</span></a> for
	  the NewReno algorithm, and <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=cc_vegas&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">cc_vegas</span>(4)</span></a> for the
	  Vegas algorithm. The default algorithm can be set by a new
	  <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">sysctl</span>(8)</span></a> variable
	  <code class="VARNAME">net.inet.tcp.cc.algorithm</code>. The
	  value must be set to one of the names listed by <code
	  class="VARNAME">net.inet.tcp.cc.available</code>, and <tt
	  class="LITERAL">newreno</tt> is the default set at boot
	  time. For more detail, see the <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=mod_cc&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">mod_cc</span>(4)</span></a> and <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=mod_cc&amp;sektion=9&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">mod_cc</span>(9)</span></a> manual
	  pages.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=216109"
	  target="_top">r216109</a>, <a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=216114"
	  target="_top">r216114</a>, <a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=216115"
	  target="_top">r216115</a>, <a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=218152"
	  target="_top">r218152</a>, <a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=218153"
	  target="_top">r218153</a>, <a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=218155"
	  target="_top">r218155</a>]</p></li>

    <li><p>An <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=h_ertt&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">h_ertt</span>(4)</span></a> (Enhanced
	  Round Trip Time) <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=khelp&amp;sektion=9&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">khelp</span>(9)</span></a> module has
	  been added. This module allows per-connection, low noise
	  estimates of the instantaneous RTT in the TCP/IP network
	  stack with a robust implementation even in the face of
	  delayed acknowledgments and/or TSO (TCP Segmentation
	  Offload) being in use for a connection.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=217806"
	  target="_top">r217806</a>]</p></li>

    <li><p>A new <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=tcp&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">tcp</span>(4)</span></a> socket option
	  <tt class="LITERAL">TCP_CONGESTION</tt> has been added. This
	  allows to select or query the congestion control algorithm
	  that the TCP/IP network stack will use for connections on
	  the socket.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=218912"
	  target="_top">r218912</a>]</p></li>

    <li><p>The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_netflow&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">ng_netflow</span>(4)</span></a> <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=netgraph&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">netgraph</span>(4)</span></a> node now
	  supports NetFlow version 9. A new <tt
	  class="LITERAL">export9</tt> hook has been added for NetFlow
	  v9 data. Note that data export can be done simultaneously in
	  both version 5 and version 9.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=219183"
	  target="_top">r219183</a>]</p></li>

    <li><p>The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=geom_map&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">geom_map</span>(4)</span></a> GEOM
	  class has been added. This allows to generate multiple geom
	  providers based on a hard-coded layout of a device with no
	  explicit partition table such as embedded flash storage. For
	  more information, see the <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=geom_map&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">geom_map</span>(4)</span></a> manual
	  page.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=220559"
	  target="_top">r220559</a>]</p></li>

    <li><p>The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=graid&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">graid</span>(8)</span></a> GEOM class
	  has been added. This is a replacement of the <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=ataraid&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">ataraid</span>(4)</span></a> driver
	  supporting various BIOS-based software RAID.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=219974"
	  target="_top">r219974</a>]</p></li>

    <li><p>A <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=tws&amp;sektion=4&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">tws</span>(4)</span></a> driver for
	  3ware 9750 SATA+SAS 6Gb/s RAID controllers has been
	  added.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=226115"
	  target="_top">r226115</a>]</p></li>

    <li><p>The FreeBSD Fast File System now supports softupdates
	journaling. It introduces a intent log into a
	softupdates-enabled file system which eliminates the need for
	background <a
	href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	<span class="CITEREFENTRY"><span
	class="REFENTRYTITLE">fsck</span>(8)</span></a> even on
	unclean shutdown. This can be enabled in a per-filesystem
	basis by using the <code class="OPTION">-j</code> flag of the
	<a
	href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	<span class="CITEREFENTRY"><span
	class="REFENTRYTITLE">newfs</span>(8)</span></a> utility or
	the <code class="OPTION">-j enable</code> option of the <a
	href="http://www.FreeBSD.org/cgi/man.cgi?query=tunefs&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	<span class="CITEREFENTRY"><span
	class="REFENTRYTITLE">tunefs</span>(8)</span></a>
	utility. Note that the 9.0-RELEASE installer automatically
	enables softupdates journaling for newly-created UFS file
	systems.[<a
	href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=207141"
	target="_top">r207141</a>, <a
	href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=218726"
	target="_top">r218726</a>]</p></li>

    <li><p>The FreeBSD Fast File System now supports the <tt
	class="LITERAL">TRIM</tt> command when freeing data blocks. A
	new flag <code class="OPTION">-t</code> in the <a
	href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	<span class="CITEREFENTRY"><span
	class="REFENTRYTITLE">newfs</span>(8)</span></a> and <a
	href="http://www.FreeBSD.org/cgi/man.cgi?query=tunefs&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	<span class="CITEREFENTRY"><span
	class="REFENTRYTITLE">tunefs</span>(8)</span></a> utilities
	sets the TRIM-enable flag for a file system. The TRIM-enable
	flag makes the file system send a delete request to the
	underlying device for each freed block. The <tt
	class="LITERAL">TRIM</tt> command is specified as a Data Set
	Management Command in the ATA8-ACS2 standard to carry the
	information related to deleted data blocks to a device,
	especially for a SSD (Solid-State Drive) for optimization.[<a
	href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=216796"
	target="_top">r216796</a>]</p></li>

    <li><p>The FreeBSD NFS subsystem has been updated. The new
	implementation supports NFS version 4 in addition to 2 and
	3. The kernel options for the NFS server and client are
	changed from <tt class="LITERAL">NFSSERVER</tt> and <tt
	class="LITERAL">NFSCLIENT</tt> to <tt
	class="LITERAL">NFSD</tt> and <tt
	class="LITERAL">NFSCL</tt>. <a
	href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	<span class="CITEREFENTRY"><span
	class="REFENTRYTITLE">sysctl</span>(8)</span></a> variables
	which start with <code class="VARNAME">vfs.nfssrv.</code> have
	been renamed to <code class="VARNAME">vfs.nfsd.</code>. The
	NFS server now supports <code
	class="VARNAME">vfs.nfsd.server_max_nfsvers</code> and <code
	class="VARNAME">vfs.nfsd.server_min_nfsvers</code> <a
	href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	<span class="CITEREFENTRY"><span
	class="REFENTRYTITLE">sysctl</span>(8)</span></a> variables to
	specify the maximum and the minimum NFS version number which
	the server accepts. The default value is set to <tt
	class="LITERAL">3</tt> and <tt class="LITERAL">2</tt>,
	respectively.[<a
	href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=221124"
	target="_top">r221124</a>]</p></li>

    <li><p>The FreeBSD ZFS subsystem has been updated to the SPA
	(Storage Pool Allocator, also known as zpool) version 28. It
	now supports data deduplication, triple parity RAIDZ (raidz3),
	snapshot holds, log device removal, zfs diff, zpool split,
	zpool import <code class="OPTION">-F</code>, and read-only
	zpool import.[<a
	href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=219089"
	target="_top">r219089</a>]</p></li>

    <li><p>An implementation of <code class="FUNCTION">iconv()</code>
	API libraries and utilities which are standardized in Single
	UNIX Specification has been imported. These are based on
	NetBSD's Citrus implementation. Note that these are not built
	nor installed by default.  To build and install them, specify
	<tt class="LITERAL">WITH_ICONV=yes</tt> in <tt
	class="FILENAME">/etc/src.conf</tt> and rebuild the base
	system as described in the <a
	href="http://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/makeworld.html"
	target="_top">FreeBSD Handbook</a>.[<a
	href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=219019"
	target="_top">r219019</a>]</p></li>

    <li><p>A <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=readline&amp;sektion=3&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">readline</span>(3)</span></a> API set
	  has been imported into <b
	  class="APPLICATION">libedit</b>. This is based on NetBSD's
	  implementation and BSD licensed utilities now use it instead
	  of GNU <b class="APPLICATION">libreadline</b>.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=220370"
	  target="_top">r220370</a>]</p></li>

    <li><p>The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=rtsold&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">rtsold</span>(8)</span></a> and <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=rtadvd&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">rtadvd</span>(8)</span></a> daemons
	  now support the RDNSS and DNSSL options described in RFC
	  6106, &#8220;IPv6 Router Advertisement Options for DNS
	  Configuration&#8221;. A <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=rtadvctl&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">rtadvctl</span>(8)</span></a> utility
	  to control the <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=rtadvd&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">rtadvd</span>(8)</span></a> daemon has
	  been added.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=222732"
	  target="_top">r222732</a>, <a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=224006"
	  target="_top">r224006</a>]</p></li>

    <li><p>The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=rtld&amp;sektion=1&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">rtld</span>(1)</span></a> runtime
	  linker now supports shared objects as filters in ELF shared
	  libraries. Both standard and auxiliary filtering have been
	  supported. The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=rtld&amp;sektion=1&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">rtld</span>(1)</span></a> linker's
	  processing of a filter defers loading a filtee until a
	  filter symbol is referenced unless the <code
	  class="VARNAME">LD_LOADFLTR</code> environment variable is
	  defined or a <tt class="LITERAL">-z loadfltr</tt> option was
	  specified when the filter was created.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=216695"
	  target="_top">r216695</a>]</p></li>

    <li><p>A bug in the <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=tftpd&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">tftpd</span>(8)</span></a> daemon has
	  been fixed. It had an interoperability issue when
	  transferring a large file.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=224536"
	  target="_top">r224536</a>]</p></li>

    <li><p>The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=utmp&amp;sektion=5&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">utmp</span>(5)</span></a> user
	  accounting database has been replaced by <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=utmpx&amp;sektion=3&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">utmpx</span>(3)</span></a>. User
	  accounting utilities will now use <tt
	  class="FILENAME">utmpx</tt> database files exclusively. The
	  <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=wtmpcvt&amp;sektion=1&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">wtmpcvt</span>(1)</span></a> utility
	  can be used to convert <tt class="FILENAME">wtmp</tt> files
	  to the new format, making it possible to read them using the
	  updated utilities.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=202188"
	  target="_top">r202188</a>]</p></li>

    <li><p>The <a
	  href="http://www.FreeBSD.org/cgi/man.cgi?query=zpool&amp;sektion=8&amp;manpath=FreeBSD+9.0-RELEASE">
	  <span class="CITEREFENTRY"><span
	  class="REFENTRYTITLE">zpool</span>(8)</span></a>: utility
	  now supports a <tt class="COMMAND">zpool labelclear</tt>
	  command. This allows to wipe the label data from a drive
	  that is not active in a pool.[<a
	  href="http://svn.freebsd.org/viewvc/base?view=revision&amp;revision=224171"
	  target="_top">r224171</a>]</p></li>
  </ul>

  <p>A list of all platforms currently under development can be found
    on the <a href="../../platforms/index.html">Supported
      Platforms</a> page.</p>

  &footer;
  </body>
</html>
